#include <windows.h>
#include <stdio.h>   

#define InitializeObjectAttributes( p, n, a, r, s ) { \
    (p)->Length = sizeof(OBJECT_ATTRIBUTES);          \
    (p)->RootDirectory = r;                             \
    (p)->Attributes = a;                                \
    (p)->ObjectName = n;                                \
    (p)->SecurityDescriptor = s;                        \
    (p)->SecurityQualityOfService = NULL;}


typedef struct _UNICODE_STRING {
    USHORT Length;
    USHORT MaximumLength;
#ifdef MIDL_PASS
    [size_is(MaximumLength / 2), length_is((Length) / 2) ] USHORT * Buffer;
#else 
    PWSTR  Buffer;
#endif 
} UNICODE_STRING;
typedef UNICODE_STRING *PUNICODE_STRING;
typedef const UNICODE_STRING *PCUNICODE_STRING;
	UNICODE_STRING UName;


typedef struct _OBJECT_ATTRIBUTES {
    ULONG Length;
    HANDLE RootDirectory;
    PUNICODE_STRING ObjectName;
    ULONG Attributes;
    PVOID SecurityDescriptor;        // Points to type SECURITY_DESCRIPTOR
    PVOID SecurityQualityOfService;  // Points to type SECURITY_QUALITY_OF_SERVICE
} OBJECT_ATTRIBUTES;
typedef OBJECT_ATTRIBUTES *POBJECT_ATTRIBUTES;
	OBJECT_ATTRIBUTES O_A;


typedef enum _SECTION_INHERIT {
    ViewShare = 1,
    ViewUnmap = 2
} SECTION_INHERIT;


typedef ULONG(*ZWO)(PHANDLE, ACCESS_MASK, POBJECT_ATTRIBUTES);
	ZWO zwo;


typedef ULONG(*RTE)(DWORD);
	RTE rte;


typedef ULONG(*RIS)(PUNICODE_STRING, PCWSTR);
	RIS ris;


typedef ULONG(*MVS)(HANDLE, HANDLE, PVOID, ULONG, ULONG, PLARGE_INTEGER, OUT PULONG, 
					SECTION_INHERIT, ULONG, ULONG);
	MVS mvs;


	int					i, mem[2];
	HMODULE				hntdll;	
	HANDLE				zw_handle;
	DWORD				zwo_err, ris_err, mvs_err, rte_err, 
						out_memory_virtual_address, memory_length, memory_address;
	LPVOID				view;
	LARGE_INTEGER		section_offset;
	WCHAR				szName[] = L"\\device\\physicalmemory";
	char				ch;


void main(){
// GET HANDLE TO NTDLL
	hntdll = GetModuleHandle("ntdll.dll");
	if(hntdll == 0) {
		printf("\n\tError getting handle to ntdll.dll.\n\n\tThis program is for Windows NT/2000/XP.");
		ExitProcess(0);}
// GET ADDRESS OF RtlInitUnicodeString
	ris = (RIS)GetProcAddress(hntdll, "RtlInitUnicodeString");
	if(ris == 0) printf("\n\tError getting address of RtlInitUnicodeString.\n");
// CONVERT NON UNICODE STRING TO UNIOCODE STRING WITH RtlInitUnicodeString
	ris_err = ris( &UName, szName );
	if(ris_err != 0)printf("\n\tError calling RtlInitUnicodeString.\n");
// FILL OBJECT ATTRIBUTE STRUCTURE, OBJ_CASE_INSENSITIVE = 0x40L
	InitializeObjectAttributes(&O_A, &UName, 0x40L, 0, 0);
// GET ADDRESS OF ZwOpenSection
	zwo = (ZWO)GetProcAddress(hntdll, "ZwOpenSection");
	if(zwo == 0) printf("\n\tError getting address of ZwOpenSection.\n");
// GET ADDRESS OF RtlNtStatusToDosError
	rte = (RTE)GetProcAddress(hntdll, "RtlNtStatusToDosError");
	if(rte == 0) printf("\n\tError getting address of RtlNtStatusToDosError.\n");
// CONVERT NT ERROR TO DOS ERROR WITH RtlNtStatusToDosError
	zwo_err = zwo(&zw_handle, SECTION_MAP_READ, &O_A);
	rte_err = (DWORD)rte(zwo_err);
// DISPLAY HANDLE TO ZwOpenSection AND ERROR CALLING IT
	printf("\n\n\tRING 3 PROGRAM TO LOOK AT COMPUTER\n\tMEMORY IN WINDOWS NT/2000/XP.\n\n\tZwOpenSection handle = %d.\n\tRtlNtStatusToDosError code = %d.\n", zw_handle, rte_err);
// GET ADDRESS OF NtMapViewOfSection
    mvs = (MVS)GetProcAddress(hntdll, "NtMapViewOfSection");
	if(mvs == 0) printf("\n\tError getting address of NtMapViewOfSection.\n");
// GET MEMORY WITH NtMapViewOfSection
	out_memory_virtual_address = 0;
	memory_length = 1;									// PAGE LENGTH = 4096 BYTES
	memory_address = 0x0FFFFF;							// ENDING ADDRESS
	section_offset.QuadPart = (ULONGLONG) (memory_address);
	mvs_err = mvs(zw_handle,							// SECTION HANDLE
				  (HANDLE)-1,							// PROCESS HANDLE
				  (PVOID)&out_memory_virtual_address,	// *OUTPUT BASE ADDRESS   
				  0L,									// ZERO BITS
				  memory_length,						// MEMORY LENGTH MEANINGFUL FOR PAGE
				  &section_offset,						// *OUTPUT OFFSET IN BYTE FROM BEGINNING
				  &memory_length,						// *OUTPUT LENGTH
				  1,									// CHILD PROCESSES
				  0,									// ALLOCATION
				  2);									// SPECIFIED PROTECTION = PAGE_READONLY = 2
	if(mvs_err != 0) printf("\n\n\tError mapping view of section = %d.\n", mvs_err);
	memory_address = section_offset.LowPart;
// UNMAP AND CLOSE	
	UnmapViewOfFile(view);
//	CloseHandle(zw_handle);
// DISPLAY BIOS DATE
	printf("\n\n\tYOUR COMPUTER BIOS DATE IS AT MEMORY\n\tADDRESS 0xFFFF5 TO 0xFFFFC AND IS ");
	for(i = 0; i < 4096; i++){
		if(i > 0XFF4 && i < 0xFFD)printf("%c", *(PUCHAR)(out_memory_virtual_address + i));}
//		if(i > 4084 && i < 4093)printf("\n\t%c", memory_address + i, *(PUCHAR)(out_memory_virtual_address + i));}
	if(mvs_err == 0)printf(".\n\n\tSTARTING ADDRESS OF MEMORY READ = 0x%X.\n\tLENGTH OF MEMORY READ = 0x%X BYTES.", memory_address, memory_length);
//*****************************************************************************************
// GET MEMORY WITH NtMapViewOfSection
	out_memory_virtual_address = 0;
	memory_length = 1;									// PAGE LENGTH = 4096 BYTES
	memory_address = 0x0000413;							// ENDING ADDRESS
	section_offset.QuadPart = (ULONGLONG) (memory_address);
	mvs_err = mvs(zw_handle,							// SECTION HANDLE
				  (HANDLE)-1,							// PROCESS HANDLE
				  (PVOID)&out_memory_virtual_address,	// *OUTPUT BASE ADDRESS   
				  0L,									// ZERO BITS
				  memory_length,						// MEMORY LENGTH MEANINGFUL FOR PAGE
				  &section_offset,						// *OUTPUT OFFSET IN BYTE FROM BEGINNING
				  &memory_length,						// *OUTPUT LENGTH
				  1,									// CHILD PROCESSES
				  0,									// ALLOCATION
				  2);									// SPECIFIED PROTECTION = PAGE_READONLY = 2
	if(mvs_err != 0) printf("\n\n\tError mapping view of section = %d.\n", mvs_err);
	memory_address = section_offset.LowPart;
// UNMAP AND CLOSE	
	UnmapViewOfFile(view);
	CloseHandle(zw_handle);
// DISPLAY COMPUTER MEMORY
	printf("\n\n\tYOUR COMPUTER MEMORY IS AT ADDRESSES:\n");
		for(i = 0; i < 4096; i++){
			if(i > 0x412 && i < 0x415){
				printf("\t\t0x%02X WITH A VALUE OF 0x%02X\n", (memory_address + i), *(PUCHAR)(out_memory_virtual_address + i));
				mem[i-0x413]=(int)*(PUCHAR)(out_memory_virtual_address + i);
			}
			}
	printf("\n\n\tYOUR COMPUTER MEMORY = %d KILOBYTES!", mem[0]+(256*mem[1]));
//*****************************************************************************************
// DISPLAY COPYRIGHT
	printf("\n\n\tFreehafer's memory program is terminated!\n\t(c)2002 INNIEA PUBLISHING CO.  R%c%cK NOG!\n\n\tHIT ENTER KEY TO EXIT . . . ", (char)153, (char)142);
    getchar();}
